<div *ngIf="campoFormulario && !campoFormulario.hidden"
     [formGroup]="campoFormulario.formulario"
>
  <div class="row" *ngIf="campoFormulario.tipoCampoHtml === 'password' || campoFormulario.tipoCampoHtml === 'text'">

    <div class="col-md-3">
      <label class="form-label"
             [for]="campoFormulario.nombreCampo"
      >
        <strong>{{campoFormulario.nombreMostrar}} {{esRequired ? '*' : ''}}:</strong>
      </label>
    </div>
    <div class="col-md-7">

      <input
        class="form-control"
        [id]="campoFormulario.nombreCampo"
        [name]="campoFormulario.nombreCampo"
        [formControlName]="campoFormulario.nombreCampo"
        [type]="campoFormulario.tipoCampoHtml"
        [placeholder]="campoFormulario.placeholderEjemplo"
        [title]="campoFormulario.textoAyuda"
      >
    </div>
    <div class="col-md-2">

      <button pButton
              pRipple
              type="button"
              icon="pi pi-times-circle"
              class="p-button-rounded p-button-text"
              (click)="limpiarCampo()"
      ></button>
    </div>
    <div class="col-md-12">
      <app-ml-ayuda-form [ayuda]="campoFormulario.textoAyuda" [id]="campoFormulario.nombreCampo"></app-ml-ayuda-form>
      <app-ml-error-form [formulario]="campoFormulario.formulario"
                         [mensajes]="campoFormulario.mensajes"
                         [nombreCampo]="campoFormulario.nombreCampo"
                         [parametros]="campoFormulario.parametros"
      ></app-ml-error-form>
    </div>
  </div>
  <div class="row" *ngIf="campoFormulario.tipoCampoHtml === 'select'">

    <div class="col-md-3">
      <label class="form-label"
             [for]="campoFormulario.nombreCampo"
      >
        <strong>{{campoFormulario.nombreMostrar}} {{esRequired ? '*' : ''}}:</strong>
      </label>
    </div>
    <div class="col-md-9" *ngIf="campoFormulario.select">
      <p-dropdown [options]="campoFormulario.select.valoresSelect"
                  [formControlName]="campoFormulario.nombreCampo"
                  [optionLabel]="campoFormulario.select.campoSeleccionado"
                  [filter]="true"
                  [filterBy]="campoFormulario.select.campoFiltrado"
                  [showClear]="true"
                  [filterPlaceholder]="campoFormulario.select.placeholderFiltro"
                  [emptyFilterMessage]="campoFormulario.select.mensajeFiltroVacio"
                  [placeholder]="campoFormulario.placeholderEjemplo"
                  [title]="campoFormulario.textoAyuda"
                  [disabled]="campoFormulario.disabled"
      >
        <ng-template let-registro pTemplate="selectedItem">
          <div *ngIf="campoFormulario.select.fnMostrarEnSelect">
            {{campoFormulario.select.fnMostrarEnSelect(registro)}}
          </div>
          <!--                    <div class="country-item country-item-value"  *ngIf="selectedCountry">-->
          <!--                      <img src="assets/showcase/images/demo/flag/flag_placeholder.png" [class]="'flag flag-' + selectedCountry.code.toLowerCase()" />-->
          <!--                      <div>{{selectedCountry.name}}</div>-->
          <!--                    </div>-->
        </ng-template>
        <ng-template let-registro pTemplate="item">
          <div *ngIf="campoFormulario.select.fnMostrarEnSelect">
            {{campoFormulario.select.fnMostrarEnSelect(registro)}}
          </div>
        </ng-template>
      </p-dropdown>

    </div>
    <div class="col-md-12">
      <app-ml-ayuda-form [ayuda]="campoFormulario.textoAyuda" [id]="campoFormulario.nombreCampo"></app-ml-ayuda-form>
      <app-ml-error-form [formulario]="campoFormulario.formulario"
                         [mensajes]="campoFormulario.mensajes"
                         [nombreCampo]="campoFormulario.nombreCampo"
                         [parametros]="campoFormulario.parametros"
      ></app-ml-error-form>
    </div>
  </div>
  <div class="row" *ngIf="campoFormulario.tipoCampoHtml === 'inputMask'">

    <div class="col-md-3">
      <label class="form-label"
             [for]="campoFormulario.nombreCampo"
      >
        <strong>{{campoFormulario.nombreMostrar}} {{esRequired ? '*' : ''}}:</strong>
      </label>
    </div>
    <div class="col-md-7" *ngIf="campoFormulario.inputMask">

      <p-inputMask [id]="campoFormulario.nombreCampo"
                   [name]="campoFormulario.nombreCampo  "
                   [formControlName]="campoFormulario.nombreCampo"
                   [placeholder]="campoFormulario.placeholderEjemplo"
                   [title]="campoFormulario.textoAyuda"
                   [mask]="campoFormulario.inputMask.mask"
                   [autoClear]="true"
                   [characterPattern]="campoFormulario.inputMask.characterPattern"
                   [slotChar]="campoFormulario.inputMask.slotChar"></p-inputMask>


    </div>
    <div class="col-md-2">

      <button pButton
              pRipple
              type="button"
              icon="pi pi-times-circle"
              class="p-button-rounded p-button-text"
              (click)="limpiarCampo()"
      ></button>
    </div>
    <div class="col-md-12">
      <app-ml-ayuda-form [ayuda]="campoFormulario.textoAyuda" [id]="campoFormulario.nombreCampo"></app-ml-ayuda-form>
      <app-ml-error-form [formulario]="campoFormulario.formulario"
                         [mensajes]="campoFormulario.mensajes"
                         [nombreCampo]="campoFormulario.nombreCampo"
                         [parametros]="campoFormulario.parametros"
      ></app-ml-error-form>
    </div>

  </div>
  <div class="row" *ngIf="campoFormulario.inputNumber && campoFormulario.tipoCampoHtml === 'inputNumber'">
    <div class="col-md-3">
      <label class="form-label"
             [for]="campoFormulario.nombreCampo"
      >
        <strong>{{campoFormulario.nombreMostrar}} {{esRequired ? '*' : ''}}:</strong>
      </label>
    </div>
    <div class="col-md-7" *ngIf="campoFormulario.inputNumber">

      <p-inputNumber
        [id]="campoFormulario.nombreCampo"
        [name]="campoFormulario.nombreCampo"
        [formControlName]="campoFormulario.nombreCampo"
        [title]="campoFormulario.textoAyuda"
        [prefix]="campoFormulario.inputNumber.prefix"
        [suffix]="campoFormulario.inputNumber.suffix"
        [min]="campoFormulario.inputNumber.min"
        [max]="campoFormulario.inputNumber.max"
        [minFractionDigits]="campoFormulario.inputNumber.minFractionDigits"></p-inputNumber>
    </div>
    <div class="col-md-2">

      <button pButton
              pRipple
              type="button"
              icon="pi pi-times-circle"
              class="p-button-rounded p-button-text"
              (click)="limpiarCampo()"
      ></button>
    </div>
    <div class="col-md-12">
      <app-ml-ayuda-form [ayuda]="campoFormulario.textoAyuda" [id]="campoFormulario.nombreCampo"></app-ml-ayuda-form>
      <app-ml-error-form [formulario]="campoFormulario.formulario"
                         [mensajes]="campoFormulario.mensajes"
                         [nombreCampo]="campoFormulario.nombreCampo"
                         [parametros]="campoFormulario.parametros"
      ></app-ml-error-form>
    </div>
  </div>
  <div class="row" *ngIf="campoFormulario.tipoCampoHtml === 'inputSwitch'">
    <div class="col-md-3">
      <label class="form-label"
             [for]="campoFormulario.nombreCampo"
      >
        <strong>{{campoFormulario.nombreMostrar}} {{esRequired ? '*' : ''}}:</strong>
      </label>
    </div>
    <div class="col-md-9">
      <div class="float-end">

        <p-inputSwitch [id]="campoFormulario.nombreCampo"
                       [name]="campoFormulario.nombreCampo"
                       [formControlName]="campoFormulario.nombreCampo"
                       [title]="campoFormulario.textoAyuda"></p-inputSwitch>
      </div>
    </div>
    <div class="col-md-12">
      <app-ml-ayuda-form [ayuda]="campoFormulario.textoAyuda" [id]="campoFormulario.nombreCampo"></app-ml-ayuda-form>
      <app-ml-error-form [formulario]="campoFormulario.formulario"
                         [mensajes]="campoFormulario.mensajes"
                         [nombreCampo]="campoFormulario.nombreCampo"
                         [parametros]="campoFormulario.parametros"
      ></app-ml-error-form>
    </div>
  </div>
  <div class="row" *ngIf="campoFormulario.autocomplete && campoFormulario.tipoCampoHtml === 'autocomplete'">
    <div class="col-md-3">
      <label class="form-label"
             [for]="campoFormulario.nombreCampo"
      >
        <strong>{{campoFormulario.nombreMostrar}} {{esRequired ? '*' : ''}}:</strong>
      </label>
    </div>
    <div class="col-md-9">
      <p-autoComplete
        [id]="campoFormulario.nombreCampo"
        [name]="campoFormulario.nombreCampo"
        [formControlName]="campoFormulario.nombreCampo"
        [title]="campoFormulario.textoAyuda"
        [suggestions]="campoFormulario.autocomplete.suggestions"
        [field]="campoFormulario.autocomplete.field"
        [dropdown]="true"
        [forceSelection]="true"
        [delay]="campoFormulario.autocomplete.delay"
        [emptyMessage]="campoFormulario.autocomplete.emptyMessage"
        [inputId]="campoFormulario.autocomplete.inputId"
        (completeMethod)="cambio($event)"
        (keydown)="empezoAEscribir()"
        (keyup)="empezoAEscribir()"
        [required]="true"
      >
        <ng-template let-registro pTemplate="item">
          <div>{{campoFormulario.autocomplete.fnMostrarEnAutoComplete(registro)}}</div>
        </ng-template>
      </p-autoComplete>


    </div>
    <div class="col-md-12">
      <app-ml-ayuda-form [ayuda]="campoFormulario.textoAyuda" [id]="campoFormulario.nombreCampo"></app-ml-ayuda-form>
      <app-ml-error-form [formulario]="campoFormulario.formulario"
                         [mensajes]="campoFormulario.mensajes"
                         [nombreCampo]="campoFormulario.nombreCampo"
                         [parametros]="campoFormulario.parametros"
      ></app-ml-error-form>
    </div>
  </div>
</div>


